## fastd 17

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
cmake_policy(SET CMP0017 OLD) # Prefer modules in our module directory

project(FASTD C ASM)
set(FASTD_VERSION "v17")

include(arch)
include(config)
include(deps)
include(checks)

set(DOXYFILE_SOURCE_DIR ${FASTD_SOURCE_DIR}/src)
include(UseDoxygen OPTIONAL)

add_subdirectory(src)

=== src/CMakeLists.txt ===
set_property(DIRECTORY PROPERTY COMPILE_DEFINITIONS _GNU_SOURCE __APPLE_USE_RFC_3542)
set(FASTD_CFLAGS "${PTHREAD_CFLAGS} -std=c99 ${UECC_CFLAGS_OTHER} ${NACL_CFLAGS_OTHER} ${OPENSSL_CRYPTO_CFLAGS_OTHER} ${JSONC_CFLAGS_OTHER} ${CFLAGS_LTO} -Wall")

include_directories(${FASTD_SOURCE_DIR} ${FASTD_BINARY_DIR}/src)
link_directories(${UECC_LIBRARY_DIRS} ${NACL_LIBRARY_DIRS} ${OPENSSL_CRYPTO_LIBRARY_DIRS} ${JSONC_LIBRARY_DIRS})


include(generate_version)

include(fastd_module)
add_subdirectory(protocols)
add_subdirectory(methods)
add_subdirectory(crypto)

include(check_reqs)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fastd_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/fastd_config.h)

BISON_TARGET(fastd_config_parse config.y ${CMAKE_CURRENT_BINARY_DIR}/config.yy.c)

add_executable(fastd
  android_ctrl_sock.c
  async.c
  capabilities.c
  config.c
  handshake.c
  hkdf_sha256.c
  fastd.c
  lex.c
  log.c
  options.c
  peer.c
  peer_hashtable.c
  poll.c
  random.c
  receive.c
  resolve.c
  send.c
  sha256.c
  shell.c
  socket.c
  status.c
  tuntap.c
  vector.c
  verify.c
  ${BISON_fastd_config_parse_OUTPUTS}
)
set_property(TARGET fastd PROPERTY COMPILE_FLAGS "${FASTD_CFLAGS}")
set_property(TARGET fastd PROPERTY LINK_FLAGS "${PTHREAD_LDFLAGS} ${UECC_LDFLAGS_OTHER} ${NACL_LDFLAGS_OTHER} ${OPENSSL_CRYPTO_LDFLAGS_OTHER} ${JSONC_LDFLAGS_OTHER} ${LDFLAGS_LTO}")
set_property(TARGET fastd APPEND PROPERTY INCLUDE_DIRECTORIES ${CAP_INCLUDE_DIR} ${NACL_INCLUDE_DIRS} ${JSONC_INCLUDE_DIRS})
target_link_libraries(fastd protocols methods ciphers macs ${RT_LIBRARY} ${CAP_LIBRARY} ${UECC_LIBRARIES} ${NACL_LIBRARIES} ${OPENSSL_CRYPTO_LIBRARIES} ${JSONC_LIBRARIES})

add_dependencies(fastd version)

install(TARGETS fastd RUNTIME DESTINATION bin)

=== src/crypto/cipher/CMakeLists.txt ===
add_library(ciphers STATIC "${CMAKE_CURRENT_BINARY_DIR}/ciphers.c")

macro(fastd_cipher name)
  fastd_module(cipher enabled "cipher" ${name} ${ARGN})

  if(${enabled})
    set_property(GLOBAL APPEND PROPERTY FASTD_CIPHERS ${name})
  endif(${enabled})
endmacro(fastd_cipher)


macro(fastd_cipher_impl cipher name)
  string(REPLACE - _ cipher_ "${cipher}")
  string(TOUPPER "${cipher_}" CIPHER)

  if(WITH_CIPHER_${CIPHER})
    fastd_module(cipher enabled "cipher implementation" "${cipher} ${name}" ${ARGN})

    if(${enabled})
      set_property(TARGET "cipher_${cipher_}" APPEND PROPERTY FASTD_CIPHER_IMPLS ${name})
    endif(${enabled})
  endif(WITH_CIPHER_${CIPHER})
endmacro(fastd_cipher_impl)

macro(fastd_cipher_impl_include_directories cipher name)
  string(REPLACE - _ cipher_ "${cipher}")
  string(TOUPPER "${cipher_}" CIPHER)

  if(WITH_CIPHER_${CIPHER})
    fastd_module_include_directories(cipher "${cipher} ${name}" ${ARGN})
  endif(WITH_CIPHER_${CIPHER})
endmacro(fastd_cipher_impl_include_directories)

macro(fastd_cipher_impl_link_libraries cipher name)
  string(REPLACE - _ cipher_ "${cipher}")
  string(TOUPPER "${cipher_}" CIPHER)

  if(WITH_CIPHER_${CIPHER})
    fastd_module_link_libraries(cipher "${cipher} ${name}" ${ARGN})
  endif(WITH_CIPHER_${CIPHER})
endmacro(fastd_cipher_impl_link_libraries)

macro(fastd_cipher_impl_require cipher name)
  string(REPLACE - _ cipher_ "${cipher}")
  string(TOUPPER "${cipher_}" CIPHER)

  if(WITH_CIPHER_${CIPHER})
    fastd_module_require(cipher "${cipher} ${name}" ${ARGN})
  endif(WITH_CIPHER_${CIPHER})
endmacro(fastd_cipher_impl_require)


add_subdirectory(aes128_ctr)
add_subdirectory(null)
add_subdirectory(salsa2012)
add_subdirectory(salsa20)


set(CIPHER_DEFINITIONS "")
set(CIPHER_IMPLS "")
set(CIPHER_LIST "")

get_property(CIPHERS GLOBAL PROPERTY FASTD_CIPHERS)
foreach(cipher ${CIPHERS})
  string(REPLACE - _ cipher_ "${cipher}")
  string(TOUPPER "${cipher_}" CIPHER)

  set(CIPHER_DEFINITIONS "${CIPHER_DEFINITIONS}\nextern const fastd_cipher_info_t fastd_cipher_info_${cipher_};")
  set(CIPHER_LIST "${CIPHER_LIST}\n{\"${cipher}\", &fastd_cipher_info_${cipher_}, cipher_${cipher_}_impls},")
  set(CIPHER_IMPLS "${CIPHER_IMPLS}\nstatic const fastd_cipher_impl_t cipher_${cipher_}_impls[] = {")


  get_property(IMPLS TARGET "cipher_${cipher_}" PROPERTY FASTD_CIPHER_IMPLS)
  foreach(impl ${IMPLS})
    set(CIPHER_DEFINITIONS "${CIPHER_DEFINITIONS}\nextern const fastd_cipher_t fastd_cipher_${cipher_}_${impl};")
    set(CIPHER_IMPLS "${CIPHER_IMPLS}{\"${impl}\", &fastd_cipher_${cipher_}_${impl}}, ")
  endforeach(impl)

  set(CIPHER_IMPLS "${CIPHER_IMPLS}{NULL, NULL}};")
endforeach(cipher)

get_property(LIBS TARGET ciphers PROPERTY FASTD_LINK_LIBRARIES)
target_link_libraries(ciphers ${LIBS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ciphers.c.in ${CMAKE_CURRENT_BINARY_DIR}/ciphers.c)

=== src/methods/composed_gmac/CMakeLists.txt ===
fastd_method(composed-gmac
  composed_gmac.c
)
fastd_method_link_libraries(composed-gmac method_common)

=== src/methods/composed_umac/CMakeLists.txt ===
fastd_method(composed-umac
  composed_umac.c
)
fastd_method_link_libraries(composed-umac method_common)

=== src/protocols/ec25519_fhmqvc/CMakeLists.txt ===
add_library(protocol_ec25519_fhmqvc OBJECT
  ec25519_fhmqvc.c
  handshake.c
  state.c
  util.c
)
set_property(TARGET protocol_ec25519_fhmqvc PROPERTY COMPILE_FLAGS "${FASTD_CFLAGS}")
set_property(TARGET protocol_ec25519_fhmqvc APPEND PROPERTY INCLUDE_DIRECTORIES ${UECC_INCLUDE_DIRS})

=== src/crypto/cipher/aes128_ctr/CMakeLists.txt ===
fastd_cipher(aes128-ctr aes128_ctr.c)
add_subdirectory(openssl)
add_subdirectory(nacl)

=== src/crypto/cipher/null/CMakeLists.txt ===
fastd_cipher(null null.c)
add_subdirectory(memcpy)

=== src/crypto/mac/uhash/CMakeLists.txt ===
fastd_mac(uhash uhash.c)
add_subdirectory(builtin)

=== src/crypto/cipher/aes128_ctr/nacl/CMakeLists.txt ===
fastd_cipher_impl(aes128-ctr nacl
  cipher_aes128_ctr_nacl.c
)
fastd_cipher_impl_include_directories(aes128-ctr nacl ${NACL_INCLUDE_DIRS})
fastd_cipher_impl_link_libraries(aes128-ctr nacl ${NACL_LIBRARIES})
fastd_cipher_impl_require(aes128-ctr nacl NACL)

=== src/crypto/cipher/aes128_ctr/openssl/CMakeLists.txt ===
if(ENABLE_OPENSSL)
  fastd_cipher_impl(aes128-ctr openssl
    aes128_ctr_openssl.c
  )
  fastd_cipher_impl_include_directories(aes128-ctr openssl ${OPENSSL_INCLUDE_DIRS})
endif(ENABLE_OPENSSL)

=== src/crypto/cipher/salsa20/xmm/CMakeLists.txt ===
if(ARCH_X86_64)
  fastd_cipher_impl(salsa20 xmm
    salsa20_xmm.c
    salsa20_amd64_xmm6.s
  )
endif(ARCH_X86_64)

if(ARCH_X86)
  fastd_cipher_impl(salsa20 xmm
    salsa20_xmm.c
    salsa20_x86_xmm5.s
  )
endif(ARCH_X86)

=== debian/changelog ===
fastd (17-4ubuntu0.1) xenial-security; urgency=medium

    [ Emilia Torino ]
    * SECURITY UPDATE: denial of service in receive.c
    - debian/patches/CVE-2020-27638.patch: fix buffer leak when receiving
      invalid packets.
    - CVE-2020-27638

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Mon, 25 Jan 2021 15:33:44 -0300

fastd (17-4build1) xenial; urgency=medium

  * No-change rebuild for libsodium transition.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Feb 2016 17:43:29 +0000

fastd (17-4) unstable; urgency=low

  * Initial upload (Closes: #801466).
  * Build against libsodium instead of libnacl

    Fixes salsa20/salsa2012 on x86 systems without SSE (e.g. Geode CPUs)

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Mon, 22 Jun 2015 23:58:01 +0200

fastd (17-3) UNRELEASED; urgency=low

  * Build binary with optimization
  * Add fastd-dbg package

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sun, 31 May 2015 21:18:35 +0200

fastd (17-2) UNRELEASED; urgency=low

  * Rebuild against versioned libuecc

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Fri, 30 Jan 2015 08:44:31 +0100

fastd (17-1) UNRELEASED; urgency=low

  * fastd v17 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Thu, 29 Jan 2015 07:30:09 +0100

fastd (16-1) UNRELEASED; urgency=low

  * fastd v16 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sat, 15 Nov 2014 18:35:49 +0100

fastd (15-1) UNRELEASED; urgency=low

  * fastd v15 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Wed, 12 Nov 2014 02:33:44 +0100

fastd (14-1) UNRELEASED; urgency=low

  * fastd v14 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Mon, 30 Jun 2014 22:03:25 +0200

fastd (12-1) UNRELEASED; urgency=low

  * fastd v12 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Fri, 14 Mar 2014 14:47:08 +0100

fastd (11-1) UNRELEASED; urgency=low

  * fastd v11 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sun, 29 Dec 2013 14:16:51 +0100

fastd (10-1) UNRELEASED; urgency=low

  * fastd v10 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Fri, 11 Oct 2013 17:02:59 +0200

fastd (9-2) UNRELEASED; urgency=low

  * Initscript improvements

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sat, 07 Sep 2013 20:45:18 +0200

fastd (9-1) UNRELEASED; urgency=low

  * fastd v9 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sat, 07 Sep 2013 19:59:08 +0200

fastd (8-2) UNRELEASED; urgency=low

  * Add init script

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Tue, 12 Mar 2013 18:39:49 +0100

fastd (8-1) UNRELEASED; urgency=low

  * fastd v8 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sun, 10 Mar 2013 18:45:09 +0100

fastd (7-1) UNRELEASED; urgency=low

  * New release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Thu, 10 Jan 2013 18:37:51 +0100

fastd (6-1) UNRELEASED; urgency=low

  * fastd v6 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sat, 10 Nov 2012 18:28:29 +0100

fastd (0.5-1) UNRELEASED; urgency=low

  * fastd v0.5 release

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Sat, 06 Oct 2012 18:16:22 +0200

=== debian/control ===
Source: fastd
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthias Schiffer <mschiffer@universe-factory.net>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.7), bison (>= 2.5), pkg-config, libcap-dev, libuecc-dev (>= 5), libsodium-dev, libssl-dev, libjson-c-dev
Standards-Version: 3.9.6
Homepage: https://projects.universe-factory.net/projects/fastd

Package: fastd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fast and Secure Tunneling Daemon
 A VPN daemon that has many features of OpenVPN and Tinc and is optimized
 for small code size and small number of dependencies. Fastd became
 popular on small devices like routers.

Package: fastd-dbg
Section: debug
Priority: extra
Architecture: any
Depends: fastd (= ${binary:Version}), ${misc:Depends}
Description: Fast and Secure Tunneling Daemon (debug symbols)
 Debug information for the fastd VPN daemon. Install if requested by the
 developer in a process to jointly find the cause of a reported problem.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RELWITHDEBINFO \
		-DENABLE_OPENSSL=ON \
		-DENABLE_SYSTEMD=ON \
		-DENABLE_LIBSODIUM=ON \
		-DENABLE_LTO=OFF \
		-DCMAKE_AR=/usr/bin/ar \
		-DCMAKE_RANLIB=/usr/bin/ranlib \
		-DCMAKE_NM=/usr/bin/nm

override_dh_strip:
	dh_strip --dbg-package=fastd-dbg

override_dh_install:
	dh_install
	install -dm755 $$(pwd)/debian/fastd/etc/fastd
	install -Dm644 doc/examples/fastd@.service $$(pwd)/debian/fastd/lib/systemd/system/fastd@.service

override_dh_installinit:
	dh_installinit --no-start -- defaults 16 80

## fastd 18

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
-cmake_minimum_required(VERSION 2.8.3)
+cmake_minimum_required(VERSION 2.8.8)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 cmake_policy(SET CMP0017 OLD) # Prefer modules in our module directory
 
 project(FASTD C ASM)
-set(FASTD_VERSION "v17")
+set(FASTD_VERSION "v18")
 
 include(arch)
 include(config)

=== src/CMakeLists.txt ===
set_property(DIRECTORY PROPERTY COMPILE_DEFINITIONS _GNU_SOURCE __APPLE_USE_RFC_3542)
set(FASTD_CFLAGS "${PTHREAD_CFLAGS} -std=c99 ${LIBUECC_CFLAGS_OTHER} ${LIBNACL_CFLAGS_OTHER} ${JSON_C_CFLAGS_OTHER} ${CFLAGS_LTO} -Wall")

include_directories(${FASTD_SOURCE_DIR} ${FASTD_BINARY_DIR}/gen)


include(generate_version)

include(fastd_module)
add_subdirectory(protocols)
add_subdirectory(methods)
add_subdirectory(crypto)

include(check_reqs)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/build.h.in ${CMAKE_BINARY_DIR}/gen/generated/build.h)

BISON_TARGET(fastd_config_parse config.y ${CMAKE_BINARY_DIR}/gen/generated/config.yy.c)

add_executable(fastd
  android.c
  async.c
  capabilities.c
  config.c
  handshake.c
  hkdf_sha256.c
  fastd.c
  iface.c
  lex.c
  log.c
  options.c
  peer.c
  peer_hashtable.c
  poll.c
  pqueue.c
  random.c
  receive.c
  resolve.c
  send.c
  sha256.c
  shell.c
  socket.c
  status.c
  task.c
  vector.c
  verify.c
  ${BISON_fastd_config_parse_OUTPUTS}
)
set_property(TARGET fastd PROPERTY COMPILE_FLAGS "${FASTD_CFLAGS}")
set_property(TARGET fastd PROPERTY LINK_FLAGS "${PTHREAD_LDFLAGS} ${LIBUECC_LDFLAGS_OTHER} ${NACL_LDFLAGS_OTHER} ${JSON_C_LDFLAGS_OTHER} ${LDFLAGS_LTO}")
set_property(TARGET fastd APPEND PROPERTY INCLUDE_DIRECTORIES ${LIBCAP_INCLUDE_DIR} ${NACL_INCLUDE_DIRS} ${JSON_C_INCLUDE_DIR})
target_link_libraries(fastd protocols methods ciphers macs ${RT_LIBRARY} ${LIBCAP_LIBRARY} ${LIBUECC_LIBRARIES} ${NACL_LIBRARIES} ${OPENSSL_CRYPTO_LIBRARY} ${JSON_C_LIBRARIES})

add_dependencies(fastd version)

install(TARGETS fastd RUNTIME DESTINATION bin)

=== src/crypto/CMakeLists.txt ===
add_subdirectory(cipher)
add_subdirectory(mac)

set(CRYPTO_SOURCES "")
list(APPEND CRYPTO_SOURCES ${CIPHER_SOURCES})
list(APPEND CRYPTO_SOURCES ${MAC_SOURCES})

set(CRYPTO_SOURCES "${CRYPTO_SOURCES}" PARENT_SCOPE)

=== src/methods/CMakeLists.txt ===
add_library(methods STATIC "${CMAKE_CURRENT_BINARY_DIR}/methods.c")
add_library(method_common STATIC EXCLUDE_FROM_ALL "common.c")

macro(fastd_method name)
  fastd_module(method enabled "method" ${name} ${ARGN})

  if(${enabled})
    set_property(GLOBAL APPEND PROPERTY FASTD_METHODS ${name})
  endif(${enabled})
endmacro(fastd_method)

macro(fastd_method_include_directories)
  fastd_module_include_directories(method ${ARGN})
endmacro(fastd_method_include_directories)

macro(fastd_method_link_libraries)
  fastd_module_link_libraries(method ${ARGN})
endmacro(fastd_method_link_libraries)

macro(fastd_method_require)
  fastd_module_require(method ${ARGN})
endmacro(fastd_method_require)


add_subdirectory(null)
add_subdirectory(cipher_test)
add_subdirectory(composed_gmac)
add_subdirectory(composed_umac)
add_subdirectory(generic_gmac)
add_subdirectory(generic_poly1305)
add_subdirectory(generic_umac)
add_subdirectory(xsalsa20_poly1305)


set(METHOD_DEFINITIONS "")
set(METHOD_LIST "")

get_property(METHODS GLOBAL PROPERTY FASTD_METHODS)
foreach(method ${METHODS})
  string(REPLACE - _ method_ "${method}")

  set(METHOD_DEFINITIONS "${METHOD_DEFINITIONS}\nextern const fastd_method_provider_t fastd_method_${method_};")
  set(METHOD_LIST "${METHOD_LIST}\n&fastd_method_${method_},")
endforeach(method)

get_property(LIBS TARGET methods PROPERTY FASTD_LINK_LIBRARIES)
target_link_libraries(methods ${LIBS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/methods.c.in ${CMAKE_CURRENT_BINARY_DIR}/methods.c)

=== src/protocols/CMakeLists.txt ===
set(PROTOCOLS ec25519_fhmqvc)

set(PROTOCOL_SOURCES "")

foreach(protocol ${PROTOCOLS})
  add_subdirectory(${protocol})
  list(APPEND PROTOCOL_SOURCES $<TARGET_OBJECTS:protocol_${protocol}>)
endforeach(protocol)

add_library(protocols STATIC ${PROTOCOL_SOURCES})

=== src/crypto/mac/CMakeLists.txt ===
add_library(macs STATIC "${CMAKE_CURRENT_BINARY_DIR}/macs.c")

macro(fastd_mac name)
  fastd_module(mac enabled "MAC" ${name} ${ARGN})

  if(${enabled})
    set_property(GLOBAL APPEND PROPERTY FASTD_MACS ${name})
  endif(${enabled})
endmacro(fastd_mac)


macro(fastd_mac_impl mac name)
  string(REPLACE - _ mac_ "${mac}")
  string(TOUPPER "${mac_}" MAC)

  if(WITH_MAC_${MAC})
    fastd_module(mac enabled "MAC implementation" "${mac} ${name}" ${ARGN})

    if(${enabled})
      set_property(TARGET "mac_${mac_}" APPEND PROPERTY FASTD_MAC_IMPLS ${name})
    endif(${enabled})
  endif(WITH_MAC_${MAC})
endmacro(fastd_mac_impl)

macro(fastd_mac_impl_include_directories mac name)
  string(REPLACE - _ mac_ "${mac}")
  string(TOUPPER "${mac_}" MAC)

  if(WITH_MAC_${MAC})
    fastd_module_include_directories(mac "${mac} ${name}" ${ARGN})
  endif(WITH_MAC_${MAC})
endmacro(fastd_mac_impl_include_directories)

macro(fastd_mac_impl_link_libraries mac name)
  string(REPLACE - _ mac_ "${mac}")
  string(TOUPPER "${mac_}" MAC)

  if(WITH_MAC_${MAC})
    fastd_module_link_libraries(mac "${mac} ${name}" ${ARGN})
  endif(WITH_MAC_${MAC})
endmacro(fastd_mac_impl_link_libraries)

macro(fastd_mac_impl_require mac name)
  string(REPLACE - _ mac_ "${mac}")
  string(TOUPPER "${mac_}" MAC)

  if(WITH_MAC_${MAC})
    fastd_module_require(mac "${mac} ${name}" ${ARGN})
  endif(WITH_MAC_${MAC})
endmacro(fastd_mac_impl_require)

macro(fastd_mac_impl_compile_flags mac name source)
  string(REPLACE - _ mac_ "${mac}")
  string(TOUPPER "${mac_}" MAC)

  if(WITH_MAC_${MAC})
    fastd_module_compile_flags(mac "${mac} ${name}" ${source} ${ARGN})
  endif(WITH_MAC_${MAC})
endmacro(fastd_mac_impl_compile_flags)


add_subdirectory(ghash)
add_subdirectory(uhash)


set(MAC_DEFINITIONS "")
set(MAC_IMPLS "")
set(MAC_LIST "")

get_property(MACS GLOBAL PROPERTY FASTD_MACS)
foreach(mac ${MACS})
  string(REPLACE - _ mac_ "${mac}")
  string(TOUPPER "${mac_}" MAC)

  set(MAC_DEFINITIONS "${MAC_DEFINITIONS}\nextern const fastd_mac_info_t fastd_mac_info_${mac_};")
  set(MAC_LIST "${MAC_LIST}\n{\"${mac}\", &fastd_mac_info_${mac_}, mac_${mac_}_impls},")
  set(MAC_IMPLS "${MAC_IMPLS}\nstatic const fastd_mac_impl_t mac_${mac_}_impls[] = {")


  get_property(IMPLS TARGET "mac_${mac_}" PROPERTY FASTD_MAC_IMPLS)
  foreach(impl ${IMPLS})
    set(MAC_DEFINITIONS "${MAC_DEFINITIONS}\nextern const fastd_mac_t fastd_mac_${mac_}_${impl};")
    set(MAC_IMPLS "${MAC_IMPLS}{\"${impl}\", &fastd_mac_${mac_}_${impl}}, ")
  endforeach(impl)

  set(MAC_IMPLS "${MAC_IMPLS}{NULL, NULL}};")
endforeach(mac)

get_property(LIBS TARGET macs PROPERTY FASTD_LINK_LIBRARIES)
target_link_libraries(macs ${LIBS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/macs.c.in ${CMAKE_CURRENT_BINARY_DIR}/macs.c)

=== src/methods/cipher_test/CMakeLists.txt ===
fastd_method(cipher-test
  cipher_test.c
)
fastd_method_link_libraries(cipher_test method_common)

=== src/methods/generic_gmac/CMakeLists.txt ===
fastd_method(generic-gmac
  generic_gmac.c
)
fastd_method_link_libraries(generic-gmac method_common)

=== src/methods/generic_poly1305/CMakeLists.txt ===
fastd_method(generic-poly1305
  generic_poly1305.c
)
fastd_method_include_directories(generic-poly1305 ${NACL_INCLUDE_DIRS})
fastd_method_link_libraries(generic-poly1305 method_common ${NACL_LIBRARIES})
fastd_method_require(generic-poly1305 NACL)

=== src/methods/generic_umac/CMakeLists.txt ===
fastd_method(generic-umac
  generic_umac.c
)
fastd_method_link_libraries(generic-umac method_common)

=== src/methods/null/CMakeLists.txt ===
fastd_method(null
  null.c
)

=== src/methods/xsalsa20_poly1305/CMakeLists.txt ===
fastd_method(xsalsa20-poly1305
  xsalsa20_poly1305.c
)
fastd_method_include_directories(xsalsa20-poly1305 ${NACL_INCLUDE_DIRS})
fastd_method_link_libraries(xsalsa20-poly1305 method_common ${NACL_LIBRARIES})
fastd_method_require(xsalsa20-poly1305 NACL)

=== debian/changelog ===
fastd (18-2+deb9u1) stretch-security; urgency=medium

  * debian/patches:
    - Add 0001-receive-fix-buffer-leak-when-receiving-invalid-packe.patch,
      CVE-2020-27638: Fix DoS'able memory leak when receiving too many
      invalid packets (Closes: #972521)

 -- Sven Eckelmann <sven@narfation.org>  Mon, 19 Oct 2020 22:42:50 +0200

fastd (18-2) unstable; urgency=medium

  * Fix operation under systemd (Closes: #823801).
  * Enable link-time optimization.

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Thu, 12 May 2016 23:02:41 +0200

fastd (18-1) unstable; urgency=low

  * New upstream release
  * Introduced hardening
  * Removed fastd-dbg package

 -- Haiko Helmholz <jo-travolti@t-online.de>  Tue, 05 Apr 2016 20:38:51 +0200

=== debian/control ===
Source: fastd
Section: net
Priority: extra
Maintainer: Matthias Schiffer <mschiffer@universe-factory.net>
Uploaders: Haiko Helmholz <jo-travolti@t-online.de>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.7), bison (>= 2.5), pkg-config, libcap-dev, libuecc-dev (>= 6), libsodium-dev, libssl-dev, libjson-c-dev, dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.8
Homepage: https://projects.universe-factory.net/projects/fastd

Package: fastd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fast and Secure Tunneling Daemon
 A VPN daemon that has many features of OpenVPN and Tinc and is optimized
 for small code size and small number of dependencies. Fastd became
 popular on small devices like routers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RELWITHDEBINFO \
		-DENABLE_OPENSSL=ON \
		-DENABLE_SYSTEMD=ON \
		-DENABLE_LIBSODIUM=ON \
		-DENABLE_LTO=ON \
		-DCMAKE_AR=/usr/bin/gcc-ar \
		-DCMAKE_NM=/usr/bin/gcc-nm \
		-DCMAKE_RANLIB=/usr/bin/gcc-ranlib

override_dh_install:
	dh_install
	install -dm755 $(CURDIR)/debian/fastd/etc/fastd
	install -m644 doc/examples/fastd@.service $(CURDIR)/debian/fastd/lib/systemd/system/fastd@.service

override_dh_installinit:
	dh_installinit --no-start -- defaults 16 80

override_dh_clean:
	dh_clean
	rm -rf obj*

override_dh_strip:
	dh_strip --dbgsym-migration=fastd-dbg

## fastd 19

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

project(FASTD C ASM)
set(FASTD_VERSION "v19")

include(arch)
include(config)
include(deps)
include(checks)

add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
   socket.c
   status.c
   task.c
+  time.c
   vector.c
   verify.c
   ${BISON_fastd_config_parse_OUTPUTS}
@@ -53,3 +54,9 @@
 add_dependencies(fastd version)
 
 install(TARGETS fastd RUNTIME DESTINATION bin)
+
+
+add_custom_target(format
+	find src -type f -name '*.[ch]' | xargs clang-format -i --style=file
+	WORKING_DIRECTORY ${FASTD_SOURCE_DIR}
+)

=== src/methods/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,6 @@
 add_subdirectory(generic_gmac)
 add_subdirectory(generic_poly1305)
 add_subdirectory(generic_umac)
-add_subdirectory(xsalsa20_poly1305)
 
 
 set(METHOD_DEFINITIONS "")

=== src/crypto/cipher/aes128_ctr/CMakeLists.txt ===
fastd_cipher(aes128-ctr aes128_ctr.c)
add_subdirectory(openssl)

=== debian/changelog ===
fastd (19-3ubuntu0.1) groovy-security; urgency=medium

    [ Emilia Torino ]
    * SECURITY UPDATE: denial of service in receive.c
    - debian/patches/CVE-2020-27638.patch: fix buffer leak when receiving
      invalid packets.
    - CVE-2020-27638

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Mon, 25 Jan 2021 15:43:26 -0300

fastd (19-3build1) groovy; urgency=medium

  * No change rebuild against new json-c ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 28 Jul 2020 17:43:00 +0100

fastd (19-3) unstable; urgency=medium

  * Upload to unstable

 -- Sven Eckelmann <sven@narfation.org>  Thu, 11 Jun 2020 13:22:35 +0200

fastd (19-2) experimental; urgency=medium

  * Add fastd-doc package with user + developer documentation (Closes: #823782)
  * debian/control:
    - Switch maintainer to Debian CommunityWLAN Team

 -- Sven Eckelmann <sven@narfation.org>  Sat, 06 Jun 2020 23:50:41 +0200

fastd (19-1) unstable; urgency=medium

  * New Upstream Version
  * debian/control:
    - Order control files with `wrap-and-sort -abst`
    - Switch to debhelper compat 13
    - Allow one to build without root
    - Add Vcs-* information
    - Fix Homepage URL
    - Upgraded to policy 4.5.0, no changes required
    - Add myself as uploader as discussed with Maintainer
    - Drop Matthias Schiffer as Maintainer as discussed with him
  * Drop unused AES128 OpenSSL 1.1 compatibility patch
  * Add debian/upstream/metadata
  * Add debian/watch
  * debian/rules:
    - Define PHONY targets
    - Use standard dh_clean
    - Restructure dh_auto_configure
    - Disable -fomit-frame-pointer
    - Drop hardcoded gcc binary paths to improve cross-compilation
    - Use debhelper's standard cmake CMAKE_BUILD_TYPE
    - Perform all installs using dh_install
  * Drop unused lintian-overrides
  * Convert debian/copyright to DEP-5

 -- Sven Eckelmann <sven@narfation.org>  Sun, 31 May 2020 15:13:54 +0200

fastd (18-3) unstable; urgency=medium

  * Update to new Debian policy and fix lintian problems.
  * Deprecate old fastd init script.
  * Fix build against libsodium 1.0.13+ (Closes: #886018).
  * Fix runtime compatibility with OpenSSL 1.1.

  * Upstream: Fixes AES128-based methods.

  * Added -fomit-frame-pointer flag. (Steffen Moeller)

 -- Matthias Schiffer <mschiffer@universe-factory.net>  Mon, 08 Jan 2018 20:48:21 +0100

=== debian/control ===
Source: fastd
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
Uploaders:
 Haiko Helmholz <jo-travolti@t-online.de>,
 Sven Eckelmann <sven@narfation.org>,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/NeoRaider/fastd
Vcs-Git: https://salsa.debian.org/communitywlan-team/fastd.git -b debian/sid
Vcs-Browser: https://salsa.debian.org/communitywlan-team/fastd
Build-Depends:
 bison (>= 2.5),
 cmake (>= 2.8.7),
 debhelper-compat (= 13),
 dpkg-dev (>= 1.16.1~),
 libcap-dev,
 libjson-c-dev,
 libsodium-dev,
 libssl-dev,
 libuecc-dev (>= 6),
 pkg-config,
 python3-sphinx,

Package: fastd
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fastd-doc,
Description: Fast and Secure Tunneling Daemon
 A VPN daemon that has many features of OpenVPN and Tinc and is optimized
 for small code size and small number of dependencies. Fastd became
 popular on small devices like routers.

Package: fastd-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-mathjax,
 ${misc:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Description: Fast and Secure Tunneling Daemon (documentation)
 A VPN daemon that has many features of OpenVPN and Tinc and is optimized
 for small code size and small number of dependencies. Fastd became
 popular on small devices like routers.
 .
 This package provides the documentation for fastd.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CMAKE_EXTRA_FLAGS :=
CMAKE_EXTRA_FLAGS += -DENABLE_OPENSSL=ON
CMAKE_EXTRA_FLAGS += -DENABLE_SYSTEMD=ON
CMAKE_EXTRA_FLAGS += -DENABLE_LIBSODIUM=ON
CMAKE_EXTRA_FLAGS += -DENABLE_LTO=ON

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --with sphinxdoc

override_dh_auto_build:
	dh_auto_build
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C doc html
endif

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_installinit:
	dh_installinit --no-start -- defaults 16 80

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_build override_dh_auto_configure override_dh_installinit

## fastd 21

=== meson_options.txt ===
option('capabilities', type : 'feature', value : 'auto')
option('cmdline_user', type : 'feature', value : 'auto')
option('cmdline_logging', type : 'feature', value : 'enabled')
option('cmdline_operation', type : 'feature', value : 'enabled')
option('cmdline_commands', type : 'feature', value : 'enabled')
option('dynamic_peers', type : 'feature', value : 'enabled')
option('status_socket', type : 'feature', value : 'enabled')
option('systemd', type : 'feature', value : 'auto')

option('cipher_aes128-ctr', type : 'feature', value : 'enabled')
option('cipher_null', type : 'feature', value : 'enabled')
option('cipher_salsa20', type : 'feature', value : 'enabled')
option('cipher_salsa20_nacl', type : 'feature', value : 'enabled')
option('cipher_salsa20_xmm', type : 'feature', value : 'auto')
option('cipher_salsa2012', type : 'feature', value : 'enabled')
option('cipher_salsa2012_nacl', type : 'feature', value : 'enabled')
option('cipher_salsa2012_xmm', type : 'feature', value : 'auto')

option('mac_ghash', type : 'feature', value : 'enabled')
option('mac_ghash_pclmulqdq', type : 'feature', value : 'auto')
option('mac_uhash', type : 'feature', value : 'enabled')

option('method_cipher-test', type : 'feature', value : 'disabled')
option('method_composed-gmac', type : 'feature', value : 'enabled')
option('method_composed-umac', type : 'feature', value : 'enabled')
option('method_generic-gmac', type : 'feature', value : 'enabled')
option('method_generic-poly1305', type : 'feature', value : 'enabled')
option('method_generic-umac', type : 'feature', value : 'enabled')
option('method_null', type : 'feature', value : 'enabled')

option('use_nacl', type : 'boolean', value : false)

option('build_tests', type : 'boolean', value : false)

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/fastd.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/fastd.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/fastd"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/fastd"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/changelog ===
fastd (21-1) unstable; urgency=high

  * New Upstream Version
    - Fix crash (assert) when receiving too many invalid packets

 -- Sven Eckelmann <sven@narfation.org>  Mon, 19 Oct 2020 21:47:58 +0200

fastd (20-1) unstable; urgency=medium

  * New Upstream Version

 -- Sven Eckelmann <sven@narfation.org>  Sat, 10 Oct 2020 19:32:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: fastd
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
+Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
 Uploaders:
  Haiko Helmholz <jo-travolti@t-online.de>,
  Sven Eckelmann <sven@narfation.org>,
@@ -12,10 +11,10 @@
 Vcs-Git: https://salsa.debian.org/communitywlan-team/fastd.git -b debian/sid
 Vcs-Browser: https://salsa.debian.org/communitywlan-team/fastd
 Build-Depends:
- bison (>= 2.5),
- cmake (>= 2.8.7),
+ bison,
  debhelper-compat (= 13),
  dpkg-dev (>= 1.16.1~),
+ meson,
  libcap-dev,
  libjson-c-dev,
  libsodium-dev,

=== debian/watch ===
version=4
https://github.com/NeoRaider/fastd/releases .*/fastd@ANY_VERSION@@ARCHIVE_EXT@

## fastd 22

=== meson_options.txt ===
--- 
+++ 
@@ -27,7 +27,11 @@
 option('method_generic-poly1305', type : 'feature', value : 'enabled')
 option('method_generic-umac', type : 'feature', value : 'enabled')
 option('method_null', type : 'feature', value : 'enabled')
+option('method_null_l2tp', type : 'feature', value : 'enabled')
 
+option('offload_l2tp', type : 'feature', value : 'auto')
+
+option('libmnl_builtin', type : 'boolean', value : false)
 option('use_nacl', type : 'boolean', value : false)
 
 option('build_tests', type : 'boolean', value : false)

=== doc/requirements.txt ===
sphinx-rtd-theme==0.5.2

=== debian/changelog ===
fastd (22-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:50:45 +1100

fastd (22-4build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:53:55 +0000

fastd (22-4) unstable; urgency=medium

  * debian/rules:
    - Install fastd@.service via dh_installsystemd
  * debian/patches:
    - Refresh patches
    - Add Fix-spelling-errors.patch, Fix spelling errors
  * debian/fastd@.service
    - Add Documentation key
  * debian/control:
    - Upgraded to policy 4.6.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 17 Dec 2022 14:57:39 +0100

fastd (22-3) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.6.1, no changes required
    - Remove versioned constraints unnecessary since buster
  * Move systemd service file to /usr/lib/systemd/system/fastd@.service
  * debian/copyright:
    - Update copyright years to 2022

 -- Sven Eckelmann <sven@narfation.org>  Mon, 14 Nov 2022 18:28:24 +0100

fastd (22-2) unstable; urgency=medium

  * Upload to unstable
  * debian/control
    - Switch to correct DEP-14 unstable branch name

 -- Sven Eckelmann <sven@narfation.org>  Sun, 15 Aug 2021 08:22:31 +0200

fastd (22-1) experimental; urgency=medium

  * New Upstream Version
  * debian/control:
    - Upgraded to policy 4.5.1, no changes required
    - Add new Build-Depends for libmnl-dev and python3-sphinx-rtd-theme
  * debian/copyright:
    - Add copyright information for new (unused) libml
    - Update copyright years
  * debian/upstream/metadata:
    - Fix path to upstream repository

 -- Sven Eckelmann <sven@narfation.org>  Sun, 27 Jun 2021 13:27:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,29 @@
 Source: fastd
 Section: net
 Priority: optional
-Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
 Uploaders:
  Haiko Helmholz <jo-travolti@t-online.de>,
  Sven Eckelmann <sven@narfation.org>,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/NeoRaider/fastd
-Vcs-Git: https://salsa.debian.org/communitywlan-team/fastd.git -b debian/sid
+Vcs-Git: https://salsa.debian.org/communitywlan-team/fastd.git -b debian/unstable
 Vcs-Browser: https://salsa.debian.org/communitywlan-team/fastd
 Build-Depends:
  bison,
  debhelper-compat (= 13),
- dpkg-dev (>= 1.16.1~),
  meson,
  libcap-dev,
  libjson-c-dev,
+ libmnl-dev,
  libsodium-dev,
  libssl-dev,
- libuecc-dev (>= 6),
+ libuecc-dev,
  pkg-config,
  python3-sphinx,
+ python3-sphinx-rtd-theme,
 
 Package: fastd
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -3,11 +3,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
-CMAKE_EXTRA_FLAGS :=
-CMAKE_EXTRA_FLAGS += -DENABLE_OPENSSL=ON
-CMAKE_EXTRA_FLAGS += -DENABLE_SYSTEMD=ON
-CMAKE_EXTRA_FLAGS += -DENABLE_LIBSODIUM=ON
-CMAKE_EXTRA_FLAGS += -DENABLE_LTO=ON
+MESON_EXTRA_FLAGS :=
+MESON_EXTRA_FLAGS += -Dsystemd=enabled
+MESON_EXTRA_FLAGS += -Db_lto=true
 
 binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
 	dh $@ --with sphinxdoc
@@ -19,7 +17,7 @@
 endif
 
 override_dh_auto_configure:
-	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
+	dh_auto_configure -- $(MESON_EXTRA_FLAGS)
 
 override_dh_installinit:
 	dh_installinit --no-start -- defaults 16 80

## fastd 23

=== doc/requirements.txt ===
Sphinx==8.1.3
sphinx-rtd-theme==3.0.2

=== debian/changelog ===
fastd (23-2) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.7.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 01 Mar 2025 20:57:46 +0100

fastd (23-1) unstable; urgency=medium

  * New Upstream Version
    - CVE-2025-24356: UDP traffic amplification via fastd's fast
      reconnect feature
  * debian/control:
    - Replace pkg-config with pkgconf
  * debian/watch:
    - Switch to api.github.com to check for releases

 -- Sven Eckelmann <sven@narfation.org>  Sun, 26 Jan 2025 16:48:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: fastd
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
+Maintainer: Debian CommunityWLAN Team <team+communitywlan@tracker.debian.org>
 Uploaders:
  Haiko Helmholz <jo-travolti@t-online.de>,
  Sven Eckelmann <sven@narfation.org>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/NeoRaider/fastd
 Vcs-Git: https://salsa.debian.org/communitywlan-team/fastd.git -b debian/unstable
@@ -21,7 +20,7 @@
  libsodium-dev,
  libssl-dev,
  libuecc-dev,
- pkg-config,
+ pkgconf,
  python3-sphinx,
  python3-sphinx-rtd-theme,
